#include <iostream>
#include <cstdlib>
#include <cmath>
#include <vector>

using namespace std;

double rnd() {
  return rand()/double(RAND_MAX);
}

double distance(vector<double> r) {
  return sqrt(r[0]*r[0]+r[1]*r[1]);
}

vector<double> random_step(vector<double> r) {
  const double pi=3.1415926535897932384626433832795;
  double x=2.0*pi*rnd();
  r[0] += cos(x);
  r[1] += sin(x);
  return r;
}

// main program, seed is passed as cmd-line argument
int main(int argc, char *argv[]) {

  if (argc!=2) {
     cerr << "Error: requires one integer argument!" << endl;
     return 1;
  }
  int seed = atoi(argv[1]);
  cerr << "Seed = " << seed << endl;
  srand(seed);

  // initial position (0,0)
  vector<double> r(2,0);

  const int NSTEP=1000000;
  int nout=10;
  for (int step=1; step<=NSTEP; step++) {
     r = random_step(r);
     if (step==nout) {
       cout << step << "\t" << distance(r) << endl;
       nout *= 10;
     }
  }
}
